<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Admin extends Core_Controller 
{

	function __construct()
	{
		parent::__construct();
	}

	function dashboard()
	{
		//If the user isn't logged in, redirect them to the login page
		if(!$this->auth->logged_in()){ header('Location: '.site_url('admin/login')); exit;}
		
		//Get the number of links to show in recents
		if(!$show = $this->uri->segment(2)) $show = '10';
		
		//Get the recent links
		$this->load->model('url_model', 'url');
		$data->recent = $this->url->get_links($show);
		
		//Get the stats
		$data->stats = $this->urli->stats();
		
		//Set some data
		$data->site_title = $this->config->item('site_title');
		$data->page_title = $this->config->item('site_title').' &rsaquo; Dashboard';
		
		//Load the views
		$this->load->view('_header', $data);
		$this->load->view('admin/dashboard_view', $data);
		$this->load->view('admin/_footer', $data);
	}
	
	function personal_settings()
	{
		//If the user isn't logged in, redirect them to the login page
		if(!$this->auth->logged_in()){ header('Location: '.site_url('admin/login')); exit;}
		
		//Process the form
		if($_POST['update'])
		{
			$post_array = array('email','password','confirm_password');
			foreach($post_array as $p)
				$data->$p = ${$p} = $_REQUEST[$p];
				
			//Validate
			if($email != $this->session->userdata('email'))
			{
				if(!preg_match('/^[_a-z0-9-+]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$/', $email))
				{
					$error = TRUE;
					$data->error_message = '<div class="error">Enter a valid email address</div>';
				}
				else if($this->auth->user_exists($email))
				{
					$error = TRUE;
					$data->error_message = '<div class="error">There is already a user with that email address</div>';
				}
				else
				{
					$update_data['email'] = $email;
				}
			}
			//If the password fields have been field in, validate them
			if(!empty($password) || !empty($confirm_password))
			{
				if($password != $confirm_password)
				{
					$error = TRUE;
					$data->error_message = '<div class="error">Your passwords do not match</div>';
				}
				else
				{
					$update_data['password'] = md5($password);
				}
			}
			//If there are no errors, update the db
			if(!$error && !empty($update_data))
			{
				//Update the db
				$this->load->model('user_model', 'user');
				$this->user->update($this->session->userdata('user_id'),$update_data);
				
				//Update the session
				$this->session->set_userdata('email', $email);
				$data->error_message = '<div class="blue">Settings updated</div>';
			}
		}
		else
		{
			$data->email = $this->session->userdata('email');
		}
		//Set some data
		$data->site_title = $this->config->item('site_title');
		$data->page_title = $this->config->item('site_title').' &rsaquo; Personal Settings';
		
		//Load the views
		$this->load->view('_header', $data);
		$this->load->view('admin/personal_settings_view', $data);
		$this->load->view('admin/_footer', $data);
	}
	
	function login()
	{
		//If the user is already logged in, redirect them to the dashboard
		if($this->auth->logged_in()){ header('Location: '.site_url('admin')); exit;}
		
		//Process the login
		if($_POST['login'])
		{
			if($this->auth->try_login($_POST['email'],$_POST['password']))
			{
				header('Location: '.base_url().$_POST['location']); exit;
			}
			else
			{
				$data->error_message = '<div class="error">Email/Password are incorrect</div>';
			}
		}
		//Set some data
		$data->site_title = $this->config->item('site_title');
		$data->page_title = $this->config->item('site_title').' &rsaquo; Login';
		
		//Load the views
		$this->load->view('_header', $data);
		$this->load->view('admin/login_view', $data);
		$this->load->view('_footer', $data);
	}
	
	function logout()
	{
		$this->auth->logout('admin/login');
	}

	function reset_password()
	{
		//If the user is already logged in, redirect them to the dashboard
		if($this->auth->logged_in()){ header('Location: '.site_url('admin/personal_settings')); exit;}
		
		//Process the login
		if($_POST['reset'])
		{
			if($this->auth->user_exists($_POST['email']))
			{
				//Reset the password
				$new = $this->auth->reset_password($_POST['email']);
				
				//Email the admin
				$this->load->library('email');

				$this->email->from($_POST['email'], 'URLi');
				$this->email->to($_POST['email']);
				$this->email->subject('URLi Password Reset');
				$this->email->message('Hey!

Your password has been reset.

Your new password is: '.$new.'

You can login at '.site_url('admin/login'));
				$this->email->send();
				
				unset($_POST['email']);
				$data->error_message = '<div class="blue">Your password has been reset, and emailed to you!</div>';
			}
			else
			{
				$data->error_message = '<div class="error">There is no user with that email address</div>';
			}
		}
		//Set some data
		$data->site_title = $this->config->item('site_title');
		$data->page_title = $this->config->item('site_title').' &rsaquo; Reset Password';
		
		//Load the views
		$this->load->view('_header', $data);
		$this->load->view('admin/reset_pass_view', $data);
		$this->load->view('_footer', $data);
	}
}

?>