<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Home extends Core_Controller 
{

	function __construct()
	{
		parent::__construct();
		if($this->config->item('protected'))
		{
			if(!$this->auth->logged_in())
			{ 
				$this->session->set_flashdata('location', ' ');
				header('Location: '.site_url('admin/login')); exit;
			}
		}
	}

	function index()
	{
		//Process the shorten form if the user has javascript dissabled or ajax is dissabled
		if($_REQUEST['url'])
		{
			$data->url = $url = $_REQUEST['url'];
			$data->custom = $custom = $_POST['custom'];
			//Validate
			if(!preg_match('/^(http(s?):\/\/|ftp:\/\/{1})?((\w+\.){1,})\w{2,}/', $url))
			{
				$error = TRUE;
				$data->error_message = '<div class="error">Enter a valid URL to shorten</div>';	
			}
			else if(!empty($custom))
			{
				if(!preg_match('/^([a-zA-Z0-9_]){1,}$/', $custom))
				{
					$error = TRUE;
					$data->error_message = '<div class="error">Enter valid custom URL</div>';
				}
				else if(!$this->urli->link_available($custom))
				{
					$error = TRUE;
					$data->error_message = '<div class="error">That custom URL has already been used</div>';
				}
			}
			//If there were no validation errors, process the form.
			if(!$error)
			{
				if($url_data = $this->urli->add_url($url,$custom))
				{
					//Add the link to the recent links in the session
					$this->urli->add_recent_link($url_data->id);
					$data->url_data = $url_data;
					unset($data->url,$data->custom);
				}
				else
				{
					$data->error_message = '<div class="error">There was an error</div>';
				}
			}
		}
		
		
		//Get the recent links from the session
		$recent = $this->session->userdata('recent_links');
		
		if(count($recent) > 0)
		{
			//If there are recent links, get them from the DB
			$this->load->model('url_model', 'url');
			$data->recents = $this->url->get_recent_links($recent);
		}
				
		//Set some data
		$data->site_title = $this->config->item('site_title');
		$data->page_title = $this->config->item('site_title');
		
		//Load the views
		$this->load->view('_header', $data);
		$this->load->view('home_view', $data);
		$this->load->view('_footer', $data);
	}
	
	function clear_recent()
	{
		$this->session->unset_userdata('recent_links');
		header('Location: '.base_url());
		exit;
	}

	function create()
	{		
		if($url = $_COOKIE['url'])
		{
			$this->index();
			setcookie('url', '', time() - 3600);	
		}
		else
		{
			header('Location: '.base_url());
		}
	}
}

?>