<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Install extends Controller 
{

	function __construct()
	{
		parent::__construct();
	}

	function index()
	{
		$this->urli->version_check();
		$this->urli->check_htaccess();

		//Check to see if URLi has been installed yet
		$data->is_installed = $this->urli->is_installed();
		
		//Process the form
		if($_POST['install'])
		{
			$post_array = array('email','password','confirm_password');
			foreach($post_array as $p)
				$data->$p = ${$p} = $_REQUEST[$p];
				
			if(!preg_match('/^[_a-z0-9-+]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$/', $email))
			{
				$error = TRUE;
				$data->error_message = '<div class="error">Enter a valid email address</div>';
			}
			else if(empty($password) || $password != $confirm_password)
			{
				$error = TRUE;
				$data->error_message = '<div class="error">Your passwords do not match</div>';
			}
			//If there are no errors, install
			if(!$error)
			{
				$this->load->helper('file');
				$sql = read_file(BASEPATH.'install_resources/install.sql');
				$sql = str_replace('#PREFIX#', $this->db->dbprefix, $sql);
				$sql = explode('--:)', $sql);
				foreach($sql as $s)
				{
					$this->db->query($s);	
				}
				//Add the admin to the DB
				$user = array(
							 	'email' => $email,
								'password' => md5($password),
								'date_created' => time()
							 );
				$this->db->insert('users', $user);
				
				//Setup the stat rows
				$stats[] = "INSERT INTO `".$this->db->dbprefix."stats` VALUES (1, 'urls_shortened', 'URLs Shortened', 0);";
				$stats[] = "INSERT INTO `".$this->db->dbprefix."stats` VALUES (2, 'total_clicks', 'Total Clicks', 0);";
				
				foreach($stats as $row)
				{
					$this->db->query($row);	
				}
				
				//Email the admin
				$this->load->library('email');

				$this->email->from($email, 'URLi');
				$this->email->to($email);
				$this->email->subject('URLi Has Been Installed!');
				$this->email->message('Hey!

URLi has successfully been installed!

You can login at '.site_url('admin/login').'

Enjoy your shortening!');
				$this->email->send();
				
				$this->session->set_flashdata('installed', TRUE);
				
				header('Location: '.site_url('admin/login'));
				exit;
			}
		}
		
		//Set some data
		$data->site_title = 'Install URLi';
		$data->page_title = 'Install';
		
		//Load the views
		$this->load->view('_header', $data);
		$this->load->view('install_view', $data);
		$this->load->view('_footer', $data);
	}

}

?>