<?php if (!defined('BASEPATH')) exit('No direct script access allowed'); 

class Urli 
{

	function __construct()
	{	
		// This makes all CI stuff available
		// under ->ci through out the class
		// eg. ->ci->load->model(...
		$this->CI =& get_instance();
		$this->CI->config->set_item('urli_version', '1.0');
	}
	//Get the title of a page from the HTML
    function get_url_title($url)
	{
		// create a new cURL resource
		$ch = curl_init();

		// set URL and other appropriate options
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt($ch, CURLOPT_TIMEOUT, 5);
		curl_setopt($ch, CURLOPT_FAILONERROR, TRUE);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
		curl_setopt($ch, CURLOPT_MAXREDIRS, 5);
		
		// grab URL and pass it to the browser
		$data = curl_exec($ch);

		// close cURL resource, and free up system resources
		curl_close($ch);
		
		//Parse the data for the page title
		if(preg_match('/<title>(.*)<\/title>/', $data, $parts))
		{
			return $parts[1];
		}
		else
		{
			return FALSE;
		}
	}
	//Create the short url key
	function create_key()
	{
		$possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890';
		$i = 1;
		while($i <= 4)
		{
			//Pick a random character
			$char = substr($possible, mt_rand(0, strlen($possible)-1), 1);
			
			$key .= $char;
			$i++;
		}
		return $key;
	}
	//Add a new url to the DB
	function add_url($url,$custom = '')
	{
		$this->CI->load->model('url_model','url');
		//Check to see if the url has been shortened before
		if(empty($custom))
		{
			if(!$this->CI->config->item('allow_duplicates'))
			{
				if($find = $this->CI->url->get_from_url($url,'id,short_key,created,link_title,clicks',TRUE))
				{
					$find->url = $url;
					$find->key = $find->short_key;
					unset($find->short_key);
					return $find;
				}
			}
		}
		//Set the link title
		if($this->CI->config->item('get_page_title') == TRUE)
		{
			//Get the page title via cURL
			if(!$link_title = $this->get_url_title($url))
			{
				$link_title = $url;
			}
		}
		else
		{
			$link_title = $url;
		}
		
		//add the URL to the DB
		$data = $this->CI->url->insert_new(
						 				   $url,
						 				   $this->create_key(),
						 				   $_SERVER['REMOTE_ADDR'],
						 				   $link_title,
										   $custom
							  		      );
		//Update the total number of URLs
		$this->CI->url->increase_url_number();

		//Return the data
		return $data;
	}
	//Check to see if a link (key) is available
	function link_available($key)
	{
		$q = $this->CI->db->get_where('urls', array('short_key_hash' => md5($key)), 1, 0);
		
		if($q->num_rows() > 0) return FALSE;
		return TRUE;
	}
	//Add a link id to the recent links in the session
	function add_recent_link($id)
	{
		$recent = $this->CI->session->userdata('recent_links');
		$count = count($recent);
		
		if(!is_array($recent))
		{
			$recent = array($id);
			$this->CI->session->set_userdata('recent_links', $recent);
		}
		else
		{
			if($count == 5) array_pop($recent);
			array_unshift($recent, $id);
			$this->CI->session->set_userdata('recent_links', $recent);
		}
	}
	//Show and chop the original URL
	function show_original($url)
	{
		if($this->CI->config->item('show_original_link'))
		{
			$url = str_replace('http://', '', $url);
			if(strlen($url) > 40)
			{
				$url = substr($url, 0, 20);
				$url .= '[...]';
			}
			$url = 'Original: '.$url;
			return $url;
		}
		return false;
	}
	//Get the stats from the db
	function stats()
	{
		$q = $this->CI->db->get('stats');
		
		return $q->result();
	}
	//Check to make sure the server is running PHP5 or later
	function version_check()
	{
		//checks php version
		if (version_compare(PHP_VERSION, '5.0.0', '<'))
		{
			$message = 'URLi is for PHP5 and later. You are using PHP version '.PHP_VERSION.'';
			die($message);
		}
	}
	//Check to make sure the .htaccess is in place
	function check_htaccess()
	{
		if(!file_exists(BASEPATH.'../.htaccess'))
		{
			$message = 'Looks like you are missing a .htaccess file. Review the "install.readme.txt" file for more information.';
			die($message);
		}
	}
	//See if URLi has been installed already
	function check_install()
	{
		//If no tables are found, move to the install controller
		if(!$this->CI->db->table_exists('urls'))
		{
			header('Location: '.site_url('install'));
			exit;
		}
	}
	//Tell if URLi has been installed or is partially installed
	function is_installed()
	{
		if($this->CI->db->table_exists('urls') || $this->CI->db->table_exists('stats') || $this->CI->db->table_exists('users'))
		{
			return TRUE;
		}
		return FALSE;
	}
	//Check for URLi udpdates
	function check_for_updates()
	{
		// create a new cURL resource
		$ch = curl_init();

		// set URL and other appropriate options
		curl_setopt($ch, CURLOPT_URL, 'http://urli.ca/check_for_updates.php');
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt($ch, CURLOPT_TIMEOUT, 15);
		curl_setopt($ch, CURLOPT_FAILONERROR, TRUE);
		
		// grab URL and pass it to the browser
		$json = curl_exec($ch);
	
		// close cURL resource, and free up system resources
		curl_close($ch);
		
		$data = json_decode($json);
		if($data->version > $this->CI->config->item('urli_version')) return $data;
		return FALSE;
	}
	//Check base color
	function check_base_color()
	{
		$base_color = $this->CI->config->item('base_color');
		if($base_color != '' && !preg_match('/([0-9A-Fa-f]{6})/', $base_color))
		{
			die('Your base color must be a hexadecimal number. Try again?');
		}
	}
}

?>