<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Url_model extends Model 
{

	function __construct()
	{
		parent::__construct();
	}
	
	//Add a new shortened URL to the db
	function insert_new($url,$key,$user_ip,$link_title,$custom)
	{
		$data = array(
		               'original_url' => $url,
					   'short_key' => $key,
		               'short_key_hash' => md5($key),
		               'created' => time(),
					   'user_ip' => $user_ip,
					   'link_title' => $link_title
		            );
		if(!empty($custom))
		{
			$data['short_key'] = $key = $custom;
			$data['short_key_hash'] = md5($custom);
			$data['custom'] = '1';
		}
		$this->db->insert('urls', $data);
		
		$return->id = $this->db->insert_id();
		$return->url = $url;
		$return->link_title = $link_title;
		$return->created = time();
		$return->key = $key;
		$return->clicks = '0';
		
		return $return;
	}
	//Update a URLs info
	function update($url_id,$data)
	{
		if(!is_array($data)) return FALSE;
		
		$this->db->where('id', $url_id);
		$this->db->update('urls', $data);
	}
	//Get the recent links for a user
	function get_recent_links($ids)
	{
		if(!is_array($ids)) return FALSE;
		
		$this->db->select('id,short_key,original_url,clicks,link_title');
		$this->db->order_by('id', 'desc'); 
		$this->db->where_in('id', $ids);
		$q = $this->db->get('urls');
		
		if($q->num_rows() > 0) return $q->result();
		return FALSE;
	}
	//Get the latest links
	function get_links($amount = '10')
	{
		$this->db->order_by('id', 'desc'); 
		$q = $this->db->get('urls', $amount, 0);
		
		if($q->num_rows() > 0) return $q->result();
		return FALSE;
	}
	//Get a url from a key
	function get_from_key($key,$select = 'id,original_url')
	{
		$this->db->select($select);
		$q = $this->db->get_where('urls', array('short_key_hash' => md5($key)), 1, 0);
		
		if($q->num_rows() == 1) return $q->row();
		return FALSE;
	}
	//Get a url from a key
	function get_from_url($url,$select = 'id',$custom = FALSE)
	{
		if($custom)
		{
			$this->db->where('custom', '0');
		}
		$this->db->select($select);
		$q = $this->db->get_where('urls', array('original_url' => $url), 1, 0);
		
		if($q->num_rows() == 1) return $q->row();
		return FALSE;
	}
	//Increase the click count of a url and stats
	function increase_clicks($id,$increase = '1')
	{
		//Update the link click count
		$this->db->where('id', $id);
		$this->db->set('clicks', "clicks+$increase", FALSE);
		$this->db->update('urls');
		
		//Update the total clicks count
		$this->db->where('stat_id', '2');
		$this->db->set('stat_value', "stat_value+$increase", FALSE);
		$this->db->update('stats');
	}
	//Increase the amount of URLs created in the stats
	function increase_url_number()
	{
		$this->db->where('stat_id', '1');
		$this->db->set('stat_value', "stat_value+1", FALSE);
		$this->db->update('stats');
	}
	
}

?>